Loading...
Searching...
No Matches
BALL::PDBAtom Class Reference
Kernel Classes » Molecular Datastructures

`#include <BALL/KERNEL/PDBAtom.h>`

Inheritance diagram for BALL::PDBAtom:

## Public Types

Enums

enum

RemotenessIndicator {
REMOTENESS_INDICATOR__UNKNOWN = BALL_PDBATOM_DEFAULT_REMOTENESS_INDICATOR , REMOTENESS_INDICATOR__ALPHA = 'A' , REMOTENESS_INDICATOR__alpha = 'a' , REMOTENESS_INDICATOR__BETA = 'B' ,
REMOTENESS_INDICATOR__beta = 'b' , REMOTENESS_INDICATOR__GAMMA = 'G' , REMOTENESS_INDICATOR__gamma = 'g' , REMOTENESS_INDICATOR__DELTA = 'D' ,
REMOTENESS_INDICATOR__delta = 'd' , REMOTENESS_INDICATOR__EPSILON = 'E' , REMOTENESS_INDICATOR__epsilon = 'e' , REMOTENESS_INDICATOR__ZETA = 'Z' ,
REMOTENESS_INDICATOR__zeta = 'z' , REMOTENESS_INDICATOR__ETA = 'H' , REMOTENESS_INDICATOR__eta = 'h' , NUMBER_OF_REMOTENESS_INDICATORS
}

enum | Property { PROPERTY__HETATM = Atom::NUMBER_OF_PROPERTIES + 1 , NUMBER_OF_PROPERTIES }
Public Types inherited from BALL::Atom
enum | { UNKNOWN_TYPE = -1 , ANY_TYPE = 0 , MAX_NUMBER_OF_BONDS = 12 }
enum | Property { NUMBER_OF_PROPERTIES = 0 }
enum | FullNameType { NO_VARIANT_EXTENSIONS , ADD_VARIANT_EXTENSIONS , ADD_RESIDUE_ID , ADD_VARIANT_EXTENSIONS_AND_ID , ADD_CHAIN_RESIDUE_ID , ADD_VARIANT_EXTENSIONS_AND_CHAIN_RESIDUE_ID }
typedef std::list< Atom * > | AtomPtrList
typedef std::list< Position > | AtomIndexList
typedef short | Type
typedef Index | BondIteratorPosition
typedef RandomAccessIterator< Atom, Bond, BondIteratorPosition, BondIteratorTraits > | BondIterator
typedef ConstRandomAccessIterator< Atom, Bond, BondIteratorPosition, BondIteratorTraits > | BondConstIterator
| Constant random access iterator for bonds.
typedef std::reverse_iterator< BondIterator > | BondReverseIterator
| Reverse random access iterator for bonds.
typedef std::reverse_iterator< BondConstIterator > | BondConstReverseIterator
| Constant reverse random access iterator for bonds.
Public Types inherited from BALL::Composite
enum | StampType { MODIFICATION = 1 , SELECTION = 2 , BOTH = 3 }
typedef UnaryPredicate< Composite > | KernelPredicateType
typedef ForwardIterator< Composite, Composite, Composite *, AncestorIteratorTraits > | AncestorIterator
typedef ConstForwardIterator< Composite, Composite, Composite *, AncestorIteratorTraits > | AncestorConstIterator
typedef BidirectionalIterator< Composite, Composite, Composite *, ChildCompositeIteratorTraits > | ChildCompositeIterator
typedef ConstBidirectionalIterator< Composite, Composite, Composite *, ChildCompositeIteratorTraits > | ChildCompositeConstIterator
typedef std::reverse_iterator< ChildCompositeIterator > | ChildCompositeReverseIterator
typedef std::reverse_iterator< ChildCompositeConstIterator > | ChildCompositeConstReverseIterator
typedef BidirectionalIterator< Composite, Composite, Composite *, CompositeIteratorTraits > | CompositeIterator
typedef ConstBidirectionalIterator< Composite, Composite, Composite *, CompositeIteratorTraits > | CompositeConstIterator
typedef std::reverse_iterator< CompositeIterator > | CompositeReverseIterator
typedef std::reverse_iterator< CompositeConstIterator > | CompositeConstReverseIterator

## Public Member Functions

Constructors and Destructors
| PDBAtom ()
| Default constructor.
| PDBAtom (const PDBAtom &pdb_atom, bool deep=true)
| Copy constructor.
| PDBAtom (const String &name)
| Constructor.

PDBAtom (Element &element, const String &name, const String &type_name=BALL_ATOM_DEFAULT_TYPE_NAME, Atom::Type atom_type=BALL_ATOM_DEFAULT_TYPE, const Vector3 &position=Vector3(BALL_ATOM_DEFAULT_POSITION), const Vector3 &velocity=Vector3(BALL_ATOM_DEFAULT_VELOCITY), const Vector3 &force=Vector3(BALL_ATOM_DEFAULT_FORCE), float charge=BALL_ATOM_DEFAULT_CHARGE, float radius=BALL_ATOM_DEFAULT_RADIUS, char branch_designator=BALL_PDBATOM_DEFAULT_BRANCH_DESIGNATOR, char remoteness_indicator=BALL_PDBATOM_DEFAULT_REMOTENESS_INDICATOR, char alternate_location_indicator=BALL_PDBATOM_DEFAULT_ALTERNATE_LOCATION_INDICATOR, float occupancy=BALL_PDBATOM_DEFAULT_OCCUPANCY, float temperature_factor=BALL_PDBATOM_DEFAULT_TEMPERATURE_FACTOR)

| Detailed constructor.
virtual | ~PDBAtom ()
| Destructor.
virtual void | destroy ()
Predicates
bool | operator== (const PDBAtom &pdb_atom) const
bool | operator!= (const PDBAtom &pdb_atom) const
Persistence
void | persistentWrite (PersistenceManager &pm, const char *name=0) const
void | persistentRead (PersistenceManager &pm)
Assignment
void | set (const PDBAtom &pdb_atom, bool deep=true)
void | get (PDBAtom &pdb_atom, bool deep=true) const
PDBAtom & | operator= (const PDBAtom &pdb_atom)
void | swap (PDBAtom &pdb_atom)
virtual void | clear ()
Accessors
Protein * | getProtein ()
const Protein * | getProtein () const
Chain * | getChain ()
const Chain * | getChain () const
Residue * | getResidue ()
const Residue * | getResidue () const
void | setBranchDesignator (char branch_designator)
char | getBranchDesignator () const
void | setRemotenessIndicator (char remoteness_indicator)
char | getRemotenessIndicator () const
void | setAlternateLocationIndicator (char alternate_location_indicator)
char | getAlternateLocationIndicator () const
void | setOccupancy (float occupancy)
float | getOccupancy () const
void | setTemperatureFactor (float temperature_factor)
float | getTemperatureFactor () const
Public Member Functions inherited from BALL::Atom
| Atom ()
| Atom (const Atom &atom, bool deep=true)

Atom (Element &element, const String &name, const String &type_name=BALL_ATOM_DEFAULT_TYPE_NAME, Type atom_type=BALL_ATOM_DEFAULT_TYPE, const Vector3 &position=Vector3(BALL_ATOM_DEFAULT_POSITION), const Vector3 &velocity=Vector3(BALL_ATOM_DEFAULT_VELOCITY), const Vector3 &force=Vector3(BALL_ATOM_DEFAULT_FORCE), float charge=BALL_ATOM_DEFAULT_CHARGE, float radius=BALL_ATOM_DEFAULT_RADIUS, Index formal_charge=BALL_ATOM_DEFAULT_FORMAL_CHARGE)

virtual | ~Atom ()
void | set (const Atom &atom, bool deep=true)
void | get (Atom &atom, bool deep=true) const
Atom & | operator= (const Atom &atom)
void | swap (Atom &atom)
bool | operator== (const Atom &atom) const
bool | operator!= (const Atom &atom) const
void | setElement (const Element &element)
| Assign the atom's element.
const Element & | getElement () const
| Return the atom's element.
void | setCharge (float charge)
float | getCharge () const
void | setFormalCharge (Index formal_charge)
| Set the atom's formal charge.
Index | getFormalCharge () const
| Return the atom's formal charge.
const Molecule * | getMolecule () const
Molecule * | getMolecule ()
| Return the molecule the atom is contained in (mutable).
const Fragment * | getFragment () const
Fragment * | getFragment ()
| Return the fragment the atom is contained in (mutable).
const Residue * | getResidue () const
Residue * | getResidue ()
| Return the residue the atom is contained in (mutable).
const SecondaryStructure * | getSecondaryStructure () const
SecondaryStructure * | getSecondaryStructure ()
| Return the secondary structure the atom is contained in (mutable).
const Chain * | getChain () const
Chain * | getChain ()
| Return the chain the atom is contained in (mutable).
void | setName (const String &name)
| Set the atom name.
const String & | getName () const
| Return the atom name.
String | getFullName (FullNameType type=ADD_VARIANT_EXTENSIONS) const
void | setPosition (const Vector3 &position)
Vector3 & | getPosition ()
| Return the atom coordinates (mutable).
const Vector3 & | getPosition () const
| Return the atom coordinates (const).
void | setRadius (float radius)
float | getRadius () const
| Return the atom radius.
void | setType (Type atom_type)
| Assign the numerical atom type.
Type | getType () const
| Return the (numerical) atom type.
String | getTypeName () const
| Return the atom type name.
void | setTypeName (const String &name)
| Assign the atom type name.
void | setVelocity (const Vector3 &velocity)
Vector3 & | getVelocity ()
const Vector3 & | getVelocity () const
void | setForce (const Vector3 &force)
const Vector3 & | getForce () const
| Return the atom's force vector (const).
Vector3 & | getForce ()
| Return the atom's force vector (mutable).
Size | countBonds () const
| Return the number of bonds.
Bond * | getBond (Position index)
const Bond * | getBond (Position index) const
Bond * | getBond (const Atom &atom)
const Bond * | getBond (const Atom &atom) const
bool | hasBond (const Bond &bond) const
bool | isBoundTo (const Atom &atom) const
bool | isBound () const
bool | isGeminal (const Atom &atom) const
bool | isVicinal (const Atom &atom) const
virtual bool | isAtom () const
virtual bool | isValid () const
bool | applyBonds (UnaryProcessor< Bond > &processor)
BondIterator | beginBond ()
| Return a bond iterator pointing to the first bond of the atom.
BondIterator | endBond ()
| Return a past-the-end bond iterator.
BondConstIterator | beginBond () const
| Return a constant bond iterator pointing to the first bond.
BondConstIterator | endBond () const
| Return a constant past-the-end bond iterator.
BondReverseIterator | rbeginBond ()
| Return a reverse bond iterator pointing to the last bond.
BondReverseIterator | rendBond ()
| Return a past-the-end bond iterator for reverse traversal.
BondConstReverseIterator | rbeginBond () const
| Return a constant reverse bond iterator pointing to the first atom.
BondConstReverseIterator | rendBond () const
| Return a constant past-the-end bond iterator for reverse traversal.
Bond * | createBond (Atom &atom)
Bond * | createBond (Bond &bond, Atom &atom)
Bond * | cloneBond (Bond &bond, Atom &atom)
bool | destroyBond (const Atom &atom)
void | destroyBonds ()
Atom * | getPartnerAtom (Position i)
const Atom * | getPartnerAtom (Position i) const
float | getDistance (const Atom &a) const
void | addInteraction (const Atom *atom, String interaction_type, double energy)
void | addInteraction (String interaction_type, double energy)
void | disableStoreInteractions ()
void | enableStoreInteractions ()
Public Member Functions inherited from BALL::Composite
template<typename T>
BALL_INLINE bool | apply (UnaryProcessor< T > &processor)
template<typename T>
BALL_INLINE bool | apply (ConstUnaryProcessor< T > &processor) const
template<typename T>
BALL_INLINE T * | getAncestor (const T &)
template<typename T>
BALL_INLINE const T * | getAncestor (const T &) const
template<typename T>
BALL_INLINE T * | getPrevious (const T &)
template<typename T>
BALL_INLINE const T * | getPrevious (const T &dummy) const
template<typename T>
BALL_INLINE T * | getNext (const T &)
template<typename T>
BALL_INLINE const T * | getNext (const T &dummy) const
template<typename T>
BALL_INLINE bool | hasAncestor (const T &dummy) const
| Composite ()
| Composite (const Composite &composite, bool deep=true)
virtual | ~Composite ()
void | destroy (bool virtual_destroy)
void * | clone (Composite &root) const
bool | operator== (const Composite &composite) const
bool | operator!= (const Composite &composite) const
bool | isEmpty () const
bool | isRoot () const
bool | isRootOf (const Composite &composite) const
bool | isInterior () const
bool | hasChild () const
bool | isChildOf (const Composite &composite) const
bool | isFirstChild () const
bool | isFirstChildOf (const Composite &composite) const
bool | isLastChild () const
bool | isLastChildOf (const Composite &composite) const
bool | hasParent () const
bool | isParentOf (const Composite &composite) const
bool | hasSibling () const
bool | isSiblingOf (const Composite &composite) const
bool | hasPreviousSibling () const
bool | isPreviousSiblingOf (const Composite &composite) const
bool | hasNextSibling () const
bool | isNextSiblingOf (const Composite &composite) const
bool | isDescendantOf (const Composite &composite) const
template<typename T>
bool | hasAncestor (const T &dummy) const
bool | isAncestorOf (const Composite &composite) const
bool | isRelatedWith (const Composite &composite) const
bool | isHomomorph (const Composite &composite) const
bool | containsSelection () const
virtual bool | isMolecule () const
virtual bool | isProtein () const
virtual bool | isFragment () const
virtual bool | isResidue () const
virtual bool | isChain () const
void | host (Visitor< Composite > &visitor)
template<typename T>
bool | applyAncestor (UnaryProcessor< T > &processor)
template<typename T>
bool | applyAncestor (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyChild (UnaryProcessor< T > &processor)
template<typename T>
bool | applyChild (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyDescendantPreorder (UnaryProcessor< T > &processor)
template<typename T>
bool | applyDescendantPreorder (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyDescendantPostorder (UnaryProcessor< T > &processor)
template<typename T>
bool | applyDescendantPostorder (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyDescendant (UnaryProcessor< T > &processor)
template<typename T>
bool | applyDescendant (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyPreorder (UnaryProcessor< T > &processor)
template<typename T>
bool | applyPreorder (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyPostorder (UnaryProcessor< T > &processor)
template<typename T>
bool | applyPostorder (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | apply (UnaryProcessor< T > &processor)
template<typename T>
bool | apply (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyLevel (UnaryProcessor< T > &processor, long level)
template<typename T>
bool | applyLevel (ConstUnaryProcessor< T > &processor, long level) const
AncestorIterator | beginAncestor ()
AncestorIterator | endAncestor ()
AncestorConstIterator | beginAncestor () const
AncestorConstIterator | endAncestor () const
ChildCompositeIterator | beginChildComposite ()
ChildCompositeIterator | endChildComposite ()
ChildCompositeConstIterator | beginChildComposite () const
ChildCompositeConstIterator | endChildComposite () const
ChildCompositeReverseIterator | rbeginChildComposite ()
ChildCompositeReverseIterator | rendChildComposite ()
ChildCompositeConstReverseIterator | rbeginChildComposite () const
ChildCompositeConstReverseIterator | rendChildComposite () const
CompositeIterator | beginComposite ()
CompositeIterator | endComposite ()
CompositeConstIterator | beginComposite () const
CompositeConstIterator | endComposite () const
CompositeReverseIterator | rbeginComposite ()
CompositeReverseIterator | rendComposite ()
CompositeConstReverseIterator | rbeginComposite () const
CompositeConstReverseIterator | rendComposite () const
void | deleteChildrenList_ (std::list< Composite * > &composites)
void | set (const Composite &composite, bool deep=true)
Composite & | operator= (const Composite &composite)
void | get (Composite &composite, bool deep=true) const
Size | getDegree () const
Size | count (const KernelPredicateType &predicate) const
Size | countDescendants () const
Size | getPathLength (const Composite &composite) const
Size | getDepth () const
Size | getHeight () const
Composite & | getRoot ()
const Composite & | getRoot () const
Composite * | getLowestCommonAncestor (const Composite &composite)
const Composite * | getLowestCommonAncestor (const Composite &composite) const
template<typename T>
T * | getAncestor (const T &)
template<typename T>
const T * | getAncestor (const T &) const
template<typename T>
T * | getPrevious (const T &)
template<typename T>
const T * | getPrevious (const T &dummy) const
template<typename T>
T * | getNext (const T &)
template<typename T>
const T * | getNext (const T &dummy) const
Composite * | getParent ()
const Composite * | getParent () const
Composite * | getChild (Index index)
const Composite * | getChild (Index index) const
Composite * | getSibling (Index index)
const Composite * | getSibling (Index index) const
Composite * | getFirstChild ()
const Composite * | getFirstChild () const
Composite * | getLastChild ()
const Composite * | getLastChild () const
const PreciseTime & | getModificationTime () const
const PreciseTime & | getSelectionTime () const
void | stamp (StampType stamp=BOTH)
void | prependChild (Composite &composite)
void | appendChild (Composite &composite)
void | insertBefore (Composite &composite)
void | insertAfter (Composite &composite)
void | spliceBefore (Composite &composite)
void | spliceAfter (Composite &composite)
void | splice (Composite &composite)
bool | removeChild (Composite &child)
Size | removeSelected ()
Size | removeUnselected ()
void | replace (Composite &composite)
void | swap (Composite &composite)
virtual void | select ()
virtual void | deselect ()
Public Member Functions inherited from BALL::PersistentObject
| PersistentObject ()
virtual | ~PersistentObject ()
PersistenceManager & | operator>> (PersistenceManager &pm) const
virtual void | finalize ()
Public Member Functions inherited from BALL::Object
| Object ()
| Default constructor.
| Object (const Object &object)
| Copy constructor.
virtual | ~Object ()
| Destructor.
const Object & | operator= (const Object &)
bool | operator== (const Object &object) const
bool | operator!= (const Object &object) const
bool | operator< (const Object &object) const
bool | operator<= (const Object &object) const
bool | operator>= (const Object &object) const
bool | operator> (const Object &object) const
int | compare (const Object &object) const
virtual void | dump (::std::ostream &s=std::cout, Size depth=0) const
Handle | getHandle () const
Public Member Functions inherited from BALL::AutoDeletable
virtual | ~AutoDeletable ()
void * | operator new (size_t size)
void | operator delete (void *ptr)
void * | operator new (size_t size, void *ptr)
void | operator delete (void *ptr, void *)
bool | isAutoDeletable () const
void | setAutoDeletable (bool enable)
Public Member Functions inherited from BALL::Selectable
| Selectable ()
| Selectable (const Selectable &selectable, bool deep=true)
virtual | ~Selectable ()
void | set (const Selectable &selectable, bool deep=true)
const Selectable & | operator= (const Selectable &selectable)
void | get (Selectable &selectable, bool deep=true) const
void | swap (Selectable &selectable)
virtual void | setSelected (bool selected)
bool | isSelected () const
bool | operator== (const Selectable &selectable) const
bool | operator!= (const Selectable &selectable) const
void | write (PersistenceManager &pm) const
bool | read (PersistenceManager &pm)
virtual void | dump (::std::ostream &s=std::cout, Size depth=0) const
Public Member Functions inherited from BALL::PropertyManager
BALL_INLINE | PropertyManager ()
| Default constructor.
BALL_INLINE | PropertyManager (const PropertyManager &property_manager)
| Copy constructor.
virtual | ~PropertyManager ()
| Destructor.
void | set (const PropertyManager &property_manager)
const PropertyManager & | operator= (const PropertyManager &property_manager)
void | get (PropertyManager &property_manager) const
void | swap (PropertyManager &property_manager)
BitVector & | getBitVector ()
const BitVector & | getBitVector () const
| operator BitVector & ()
void | setProperty (Property property)
void | clearProperty (Property property)
void | toggleProperty (Property property)
Size | countProperties () const
const NamedProperty & | getNamedProperty (Position index) const
NamedProperty & | getNamedProperty (Position index)
void | setProperty (const NamedProperty &property)
void | setProperty (const std::string &name)
void | setProperty (const std::string &name, bool value)
void | setProperty (const std::string &name, int value)
void | setProperty (const std::string &name, unsigned int value)
void | setProperty (const std::string &name, float value)
void | setProperty (const std::string &name, double value)
void | setProperty (const std::string &name, const std::string &value)
void | setProperty (const std::string &name, const PersistentObject &value)
const NamedProperty & | getProperty (const std::string &name) const
NamedPropertyIterator | beginNamedProperty ()
NamedPropertyIterator | endNamedProperty ()
void | clearProperty (const std::string &name)
Size | countNamedProperties () const
bool | hasProperty (Property property) const
| Query for an unnamed property.
bool | hasProperty (const std::string &name) const
| Query for a named property.
bool | operator== (const PropertyManager &pm) const
bool | operator!= (const PropertyManager &pm) const
| Inequality operator.
void | write (PersistenceManager &pm) const
| Persistent stream writing.
bool | read (PersistenceManager &pm)
| Persistent stream reading.
bool | isValid () const
void | dump (std::ostream &s=std::cout, Size depth=0) const

## Friends

class | Bond

## Debugging and Diagnostics

virtual void | dump (std::ostream &s=std::cout, Size depth=0) const

## Additional Inherited Members

static bool | insertParent (Composite &parent, Composite &first, Composite &last, bool destroy_parent=true)
static Handle | getNextHandle ()
static Handle | getNewHandle ()
static void | clearLastPtr ()
MolecularInteractions * | interactions
bool | store_interactions_disabled_
static UnaryProcessor< Composite > | DEFAULT_PROCESSOR
static KernelPredicateType | DEFAULT_UNARY_PREDICATE
| AutoDeletable ()
| AutoDeletable (const AutoDeletable &auto_deletable, bool deep=false)
String | name_
String | type_name_
const Element * | element_
float | radius_
Type | type_
unsigned char | number_of_bonds_
Bond * | bond_ [MAX_NUMBER_OF_BONDS]
Index | formal_charge_
Vector3 | position_
float | charge_
Vector3 | velocity_
Vector3 | force_
bool | selected_
static AtomIndexList | free_list_

## Detailed Description

Atom class with additional attributes. This class represents atoms read from PDB files. It contains additional attributes to hold the crystallographic properties of atoms from a PDB file (e.g., temperature factor, occupancy). For details on the PDB format and the detailed meaning of those fields, please refer to the PDB documentation at http://www.rcsb.org

See also
  PDBFile

Definition at line 38 of file PDBAtom.h.

## Member Enumeration Documentation

## Property

enum BALL::PDBAtom::Property

Properties of the PDBAtom.

Enumerator
PROPERTY__HETATM | Property which indicates whether the current atom is a HETATM.
NUMBER_OF_PROPERTIES | The number of properties in PDBAtom.

Definition at line 76 of file PDBAtom.h.

## RemotenessIndicator

enum BALL::PDBAtom::RemotenessIndicator

Possible values for the PDB remoteness indicator

Enumerator
REMOTENESS_INDICATOR__UNKNOWN |
REMOTENESS_INDICATOR__ALPHA |
REMOTENESS_INDICATOR__alpha |
REMOTENESS_INDICATOR__BETA |
REMOTENESS_INDICATOR__beta |
REMOTENESS_INDICATOR__GAMMA |
REMOTENESS_INDICATOR__gamma |
REMOTENESS_INDICATOR__DELTA |
REMOTENESS_INDICATOR__delta |
REMOTENESS_INDICATOR__EPSILON |
REMOTENESS_INDICATOR__epsilon |
REMOTENESS_INDICATOR__ZETA |
REMOTENESS_INDICATOR__zeta |
REMOTENESS_INDICATOR__ETA |
REMOTENESS_INDICATOR__eta |
NUMBER_OF_REMOTENESS_INDICATORS |

Definition at line 53 of file PDBAtom.h.

## Constructor & Destructor Documentation

## PDBAtom() [1/4]

BALL::PDBAtom::PDBAtom | ( |  | ) |

Default constructor.

## PDBAtom() [2/4]

BALL::PDBAtom::PDBAtom | ( | const PDBAtom & | pdb_atom,
|  | bool | deep = true )

Copy constructor.

## PDBAtom() [3/4]

BALL::PDBAtom::PDBAtom | ( | const String & | name | ) |

Constructor.

## PDBAtom() [4/4]

BALL::PDBAtom::PDBAtom | ( | Element & | element,
|  | const String & | name,
|  | const String & | type_name = BALL_ATOM_DEFAULT_TYPE_NAME,
|  | Atom::Type | atom_type = BALL_ATOM_DEFAULT_TYPE,
|  | const Vector3 & | position = Vector3(BALL_ATOM_DEFAULT_POSITION),
|  | const Vector3 & | velocity = Vector3(BALL_ATOM_DEFAULT_VELOCITY),
|  | const Vector3 & | force = Vector3(BALL_ATOM_DEFAULT_FORCE),
|  | float | charge = BALL_ATOM_DEFAULT_CHARGE,
|  | float | radius = BALL_ATOM_DEFAULT_RADIUS,
|  | char | branch_designator = BALL_PDBATOM_DEFAULT_BRANCH_DESIGNATOR,
|  | char | remoteness_indicator = BALL_PDBATOM_DEFAULT_REMOTENESS_INDICATOR,
|  | char | alternate_location_indicator = BALL_PDBATOM_DEFAULT_ALTERNATE_LOCATION_INDICATOR,
|  | float | occupancy = BALL_PDBATOM_DEFAULT_OCCUPANCY,
|  | float | temperature_factor = BALL_PDBATOM_DEFAULT_TEMPERATURE_FACTOR )

Detailed constructor.

## ~PDBAtom()

virtual BALL::PDBAtom::~PDBAtom | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## clear()

virtual void BALL::PDBAtom::clear | ( |  | ) |

virtual

Clear the contents of the atom.

Reimplemented from BALL::Atom.

## destroy()

virtual void BALL::PDBAtom::destroy | ( |  | ) |

virtual

Clears the contents of the atom and removes it from all composite structures.

Reimplemented from BALL::Atom.

## dump()

virtual void BALL::PDBAtom::dump | ( | std::ostream & | s = std::cout,
|  | Size | depth = 0 ) const

virtual

Internal state dump. Dump the current internal state of {*this} to the output ostream s with dumping depth depth .

Parameters

  s | output stream where to output the internal state of the instance
  depth | the dumping depth

Reimplemented from BALL::Atom.

## get()

void BALL::PDBAtom::get | ( | PDBAtom & | pdb_atom,
|  | bool | deep = true ) const

Copy this instance to {pdb_atom}. The assignment is either deep or shallow (default).

Parameters

  pdb_atom | the PDBAtom to be assigned to

## getAlternateLocationIndicator()

char BALL::PDBAtom::getAlternateLocationIndicator | ( |  | ) | const

Get the alternate location indicator.

Returns
  char the alternate location indicator

## getBranchDesignator()

char BALL::PDBAtom::getBranchDesignator | ( |  | ) | const

Get the branch designator.

Returns
  char the branch designator

## getChain() [1/2]

Chain * BALL::PDBAtom::getChain | ( |  | ) |

Get a pointer to the parent chain. The pointer is 0 if the instance does not have a parent chain.

Returns
  Chain* - mutable pointer to the parent chain

## getChain() [2/2]

const Chain * BALL::PDBAtom::getChain | ( |  | ) | const

Get a pointer to the parent chain. The pointer is 0 if the instance does not have a parent chain.

Returns
  Chain* - constant pointer to the parent chain

## getOccupancy()

float BALL::PDBAtom::getOccupancy | ( |  | ) | const

Get the occupancy.

Returns
  float occupancy the occupancy

## getProtein() [1/2]

Protein * BALL::PDBAtom::getProtein | ( |  | ) |

Get a pointer to the parent protein. The pointer is 0 if the instance does not have a parent protein.

Returns
  Protein* - mutable pointer to the parent protein

## getProtein() [2/2]

const Protein * BALL::PDBAtom::getProtein | ( |  | ) | const

Get a pointer to the parent protein. The pointer is 0 if the instance does not have a parent protein.

Returns
  Protein* - constant pointer to the parent protein

## getRemotenessIndicator()

char BALL::PDBAtom::getRemotenessIndicator | ( |  | ) | const

Get the remoteness indicator.

Returns
  char the remoteness indicator

## getResidue() [1/2]

Residue * BALL::PDBAtom::getResidue | ( |  | ) |

Get a pointer to the parent residue. The pointer is 0 if the instance does not have a parent residue.

Returns
  Residue* - mutable pointer to the parent residue

## getResidue() [2/2]

const Residue * BALL::PDBAtom::getResidue | ( |  | ) | const

Get a pointer to the parent residue. The pointer is 0 if the instance does not have a parent residue.

Returns
  Residue* - constant pointer to the parent residue

## getTemperatureFactor()

float BALL::PDBAtom::getTemperatureFactor | ( |  | ) | const

Get the temperature factor.

Returns
  float the temperature factor

## operator!=()

bool BALL::PDBAtom::operator!= | ( | const PDBAtom & | pdb_atom | ) | const

Inequality operator

See also
  operator ==

## operator=()

PDBAtom & BALL::PDBAtom::operator= | ( | const PDBAtom & | pdb_atom | ) |

Assignment operator. The assignment is deep.

Parameters

  pdb_atom | the PDBAtom to be copied (cloned)

Returns
  pdb_atom& - the instance

## operator==()

bool BALL::PDBAtom::operator== | ( | const PDBAtom & | pdb_atom | ) | const

Equality operator.

See also
  Object::operator ==

## persistentRead()

void BALL::PDBAtom::persistentRead | ( | PersistenceManager & | pm | ) |

virtual

Reads a PDBAtom object from a persistent stream.

Parameters

  pm | the persistence manager

Reimplemented from BALL::Atom.

## persistentWrite()

void BALL::PDBAtom::persistentWrite | ( | PersistenceManager & | pm,
|  | const char * | name = 0 ) const

virtual

Writes a PDBAtom object to a persistent stream.

Parameters

  pm | the persistence manager
  name | the instance name

Reimplemented from BALL::Atom.

## set()

void BALL::PDBAtom::set | ( | const PDBAtom & | pdb_atom,
|  | bool | deep = true )

Assignment with cloning facility. The assignment is either deep or shallow (default).

Parameters

  pdb_atom | the PDBAtom to be copied (cloned)
  deep | make a deep (=true) or shallow (=false) copy

## setAlternateLocationIndicator()

void BALL::PDBAtom::setAlternateLocationIndicator | ( | char | alternate_location_indicator | ) |

Set the alternate location indicator.

Parameters

  alternate_location_indicator | the alternate location indicator

## setBranchDesignator()

void BALL::PDBAtom::setBranchDesignator | ( | char | branch_designator | ) |

Set the branch designator.

Parameters

  branch_designator | the branch designator

## setOccupancy()

void BALL::PDBAtom::setOccupancy | ( | float | occupancy | ) |

Set the occupancy.

Parameters

  occupancy | the occupancy

## setRemotenessIndicator()

void BALL::PDBAtom::setRemotenessIndicator | ( | char | remoteness_indicator | ) |

Set the remoteness indicator.

Parameters

  remoteness_indicator | the remoteness indicator

## setTemperatureFactor()

void BALL::PDBAtom::setTemperatureFactor | ( | float | temperature_factor | ) |

Set the temperature factor.

Parameters

  temperature_factor | the temperature factor

## swap()

void BALL::PDBAtom::swap | ( | PDBAtom & | pdb_atom | ) |

Swapping of PDBAtoms.

Parameters

  pdb_atom | the PDBAtom {*this} is being swapped with

## Friends And Related Symbol Documentation

## Bond

friend class Bond

friend

Definition at line 43 of file PDBAtom.h.